#include "psi_freq.h"
#include "amino_acid.h"
#pragma warning(disable : 4996)


double blosum62[20][20]=
{	//A  R  N  D  C  Q  E  G  H  I  L  K  M  F  P  S  T  W  Y  V
	{4,-1,-2, -2,  0, -1, -1,  0, -2, -1, -1, -1, -1, -2, -1,  1,  0, -3, -2,  0},
	{-1,5, 0, -2, -3,  1,  0, -2,  0, -3, -2,  2, -1, -3, -2, -1, -1, -3, -2, -3},
	{-2,0, 6,  1, -3,  0,  0,  0,  1, -3, -3,  0, -2, -3, -2,  1,  0, -4, -2, -3},
	{-2,-2, 1,  6, -3,  0,  2, -1, -1, -3, -4, -1, -3, -3, -1,  0, -1, -4, -3, -3},
	{0,-3, -3, -3,  9, -3, -4, -3, -3, -1, -1, -3, -1, -2, -3, -1, -1, -2, -2, -1},
	{-1,1, 0,  0, -3,  5,  2, -2,  0, -3, -2,  1,  0, -3, -1,  0, -1, -2, -1, -2},
	{-1,0, 0,  2, -4,  2,  5, -2,  0, -3, -3,  1, -2, -3, -1,  0, -1, -3, -2, -2},
	{0,-2, 0, -1, -3, -2, -2,  6, -2, -4, -4, -2, -3, -3, -2,  0, -2, -2, -3, -3},
	{-2,0, 1, -1, -3,  0,  0, -2,  8, -3, -3, -1, -2, -1, -2, -1, -2, -2,  2, -3},
	{-1, -3,-3, -3, -1, -3, -3, -4, -3,  4,  2, -3,  1,  0, -3, -2, -1, -3, -1,  3},
	{-1, -2,-3, -4, -1, -2, -3, -4, -3,  2,  4, -2,  2,  0, -3, -2, -1, -2, -1,  1},
	{-1,  2, 0, -1, -3,  1,  1, -2, -1, -3, -2,  5, -1, -3, -1,  0, -1, -3, -2, -2},
	{-1, -1,-2, -3, -1,  0, -2, -3, -2,  1,  2, -1,  5,  0, -2, -1, -1, -1, -1,  1},
	{-2, -3,-3, -3, -2, -3, -3, -3, -1,  0,  0, -3,  0,  6, -4, -2, -2,  1,  3, -1},
	{-1, -2,-2, -1, -3, -1, -1, -2, -2, -3, -3, -1, -2, -4,  7, -1, -1, -4, -3, -2},
	{1, -1, 1,  0, -1,  0,  0,  0, -1, -2, -2,  0, -1, -2, -1,  4,  1, -3, -2, -2},
	{0, -1, 0, -1, -1, -1, -1, -2, -2, -1, -1, -1, -1, -2, -1,  1,  5, -2, -2,  0},
	{-3, -3,-4, -4, -2, -2, -3, -2,-2, -3, -2, -3, -1,  1, -4, -3, -2, 11,  2, -3},
	{-2, -2,-2, -3, -2, -1, -2, -3,  2, -1, -1, -2, -1,  3, -3, -2, -2,  2,  7, -1},
	{0, -3,-3, -3, -1, -2, -2, -3, -3,  3,  1, -2,  1, -1, -2, -2,  0, -3, -1,  4}
}; 
double lamba=0.318;

double P[20]={0.081577,0.0167762,0.0576259,0.0692897,0.0398235,0.072874,0.0230074,0.0567315,0.0616455,0.0912648,0.0184333,0.0428513,0.0452831,0.0389125,0.0515539,0.0587903,0.0538215,0.0711493,0.0139555,0.0345576};//ᱳƵ
sequence::sequence()
{
	start=0;
	end=0;
	seq_identity=0;
}
void sequence::Clear()
{
	name.clear();
	seq.clear();
	start=0;
	end=0;
	seq_identity=0;
}

bool psi_freq(string fname,vector<vector<double> >& freq,string& sequ,string standseq)
{
	vector<sequence> all_seq;
	vector<double> one_profile;
	vector<int> miss;
	vector<int> use;
	vector<int> nc;
	vector<double> weight_seq;
	
	int len,po;
	int i,j,k,r,len_colum,index;
	char aa;
	bool find;
	double temp,total_weight,score,alpha,beta;
	double f[20],g[20];
	vector<double> Q;
	if(!read_multiali_psi_multimap(fname,all_seq,miss))
		return false;	
	if((int)all_seq.size()<=0)
		return false;
	
	len=(int)standseq.length();
	po=all_seq[0].end;
	if(len!=po)
	{
		for(i=po+1;i<=len;i++)
			miss.push_back(i);
	}
	
	
	len=(int)all_seq.size();
	use.resize(len);
	use[0]=1;
	for(i=1;i<len;i++)
	{
		find=false;
		if(Simi_AliSeq_query(all_seq[i].seq,all_seq[0].seq)>0.98)
			find=true;
		if(!find)
		{
			for(j=1;j<i;j++)
			{	
				if(use[j])
				{
					if(Simi_AliSeq_seq(all_seq[i].seq,all_seq[j].seq)>0.98)
					{
						find=true;
						break;
					}
				}
			}
		}
		if(!find)
			use[i]=1;
		else
			use[i]=0;
	}	
	
	len=(int)all_seq[0].seq.length();
	vector<vector<double> > weight_aa;
	weight_aa.resize(21);
	for(i=0;i<21;i++)
		weight_aa[i].resize(len,0);
	len_colum=(int)all_seq.size();
	weight_seq.resize(len_colum);
	for(i=0;i<len;i++)
	{
		for(j=0;j<len_colum;j++)
		{
			if(use[j])
			{
				aa=all_seq[j].seq[i];
				if(aa==' ')
					continue;
				if(aa=='-')
					weight_aa[20][i]+=1.0;
				index=Rname2ID20(aa);
				if(index!=-1)
					weight_aa[index][i]+=1.0;
			}
		}
	}
	nc.resize(len);
	for(i=0;i<len;i++)
	{
		r=0;
		for(j=0;j<21;j++)
		{
			if(fabs(weight_aa[j][i])>0.5)
				r++;
		}
		nc[i]=r-1;
		for(j=0;j<21;j++)
		{
			if(fabs(weight_aa[j][i])>0.5)
			{
				temp=weight_aa[j][i];
				weight_aa[j][i]=1.0/(r*weight_aa[j][i]);
			}
		}
	}
	
	for(i=0;i<len_colum;i++)
	{
		weight_seq[i]=0;
		if(use[i])
		{
			for(j=0;j<len;j++)
			{
				aa=all_seq[i].seq[j];
				index=Rname2ID20(aa);
				if(index!=-1)
				{
					temp=weight_aa[index][j];
					weight_seq[i]+=weight_aa[index][j];
				}
			}
		}
	}
	len=(int)all_seq[0].seq.length();
	freq.clear();
	freq.resize(len);
	Q.resize(20);
	for(i=0;i<len;i++)
	{
	
		for(j=0;j<20;j++)
			f[j]=0;	
		total_weight=0;
		for(j=0;j<len_colum;j++)
		{
			if(use[j])
			{
				aa=all_seq[j].seq[i];
				if(aa=='-')             
					total_weight+=weight_seq[j];
				index=Rname2ID20(aa);
				if(index!=-1)
				{
					f[index]+=weight_seq[j];
					total_weight+=weight_seq[j];
				}
			}
		}
		for(j=0;j<20;j++)
		{
			if(fabs(total_weight)<1e-10)
				f[j]=0;
			else
				f[j]/=total_weight;	
		}
		
		for(k=0;k<20;k++)
		{
			g[k]=0;
			for(j=0;j<20;j++)
			{
				score=blosum62[aarank2psi[k]][aarank2psi[j]];
				g[k]+=f[j]*P[k]*exp(lamba*score);
			}
		}
		for(j=0;j<20;j++)
		{
			alpha=nc[i];
			//alpha=len_colum;
			beta=10;
			Q[j]=(alpha*f[j]+beta*g[j])/(alpha+beta);			
		}
		freq[i]=Q;
	}
	

	sequ=all_seq[0].seq;
	
	one_profile.resize(20);
	string tempstr;
	for(i=0;i<(int)miss.size();i++)
	{
		po=miss[i]-1;
		if((po>=0)&&(po<(int)standseq.length()))
		{
			aa=standseq[po];
			tempstr=aa;
			sequ.insert(po,tempstr);
			k=Rname2ID20(aa);
			for(j=0;j<20;j++)
				one_profile[j]=0;
			if(k!=-1)
				one_profile[k]=1.0;
			freq.insert(freq.begin()+po,one_profile);
		}
	}
	return true;
}

bool psi_freq_outali(string fname,string outname,vector<vector<double> >& freq,string& sequ,string standseq)
{
	vector<sequence> all_seq;
	vector<double> one_profile;
	vector<int> miss;
	vector<int> use;
	vector<int> nc;
	vector<double> weight_seq;
	
	int len,po;
	int i,j,k,r,len_colum,index;
	char aa;
	bool find;
	double temp,total_weight,score,alpha,beta;
	double f[20],g[20];
	vector<double> Q;
	if(!read_multiali_psi_multimap(fname,all_seq,miss))
		return false;	
	if((int)all_seq.size()<=0)
		return false;
	if(!write_multiali(outname,all_seq))
		return false;
	
	len=(int)standseq.length();
	po=all_seq[0].end;
	if(len!=po)
	{
		for(i=po+1;i<=len;i++)
			miss.push_back(i);
	}
	
	
	len=(int)all_seq.size();
	use.resize(len);
	use[0]=1;
	for(i=1;i<len;i++)
	{
		find=false;
		if(Simi_AliSeq_query(all_seq[i].seq,all_seq[0].seq)>0.98)
			find=true;
		if(!find)
		{
			for(j=1;j<i;j++)
			{	
				if(use[j])
				{
					if(Simi_AliSeq_seq(all_seq[i].seq,all_seq[j].seq)>0.98)
					{
						find=true;
						break;
					}
				}
			}
		}
		if(!find)
			use[i]=1;
		else
			use[i]=0;
	}	
	
	len=(int)all_seq[0].seq.length();
	vector<vector<double> > weight_aa;
	weight_aa.resize(21);
	for(i=0;i<21;i++)
		weight_aa[i].resize(len,0);
	len_colum=(int)all_seq.size();
	weight_seq.resize(len_colum);
	for(i=0;i<len;i++)
	{
		for(j=0;j<len_colum;j++)
		{
			if(use[j])
			{
				aa=all_seq[j].seq[i];
				if(aa==' ')
					continue;
				if(aa=='-')
					weight_aa[20][i]+=1.0;
				index=Rname2ID20(aa);
				if(index!=-1)
					weight_aa[index][i]+=1.0;
			}
		}
	}
	nc.resize(len);
	for(i=0;i<len;i++)
	{
		r=0;
		for(j=0;j<21;j++)
		{
			if(fabs(weight_aa[j][i])>0.5)
				r++;
		}
		nc[i]=r-1;
		for(j=0;j<21;j++)
		{
			if(fabs(weight_aa[j][i])>0.5)
			{
				temp=weight_aa[j][i];
				weight_aa[j][i]=1.0/(r*weight_aa[j][i]);
			}
		}
	}
	
	for(i=0;i<len_colum;i++)
	{
		weight_seq[i]=0;
		if(use[i])
		{
			for(j=0;j<len;j++)
			{
				aa=all_seq[i].seq[j];
				index=Rname2ID20(aa);
				if(index!=-1)
				{
					temp=weight_aa[index][j];
					weight_seq[i]+=weight_aa[index][j];
				}
			}
		}
	}
	len=(int)all_seq[0].seq.length();
	freq.clear();
	freq.resize(len);
	Q.resize(20);
	for(i=0;i<len;i++)
	{
	
		for(j=0;j<20;j++)
			f[j]=0;	
		total_weight=0;
		for(j=0;j<len_colum;j++)
		{
			if(use[j])
			{
				aa=all_seq[j].seq[i];
				if(aa=='-')             
					total_weight+=weight_seq[j];
				index=Rname2ID20(aa);
				if(index!=-1)
				{
					f[index]+=weight_seq[j];
					total_weight+=weight_seq[j];
				}
			}
		}
		for(j=0;j<20;j++)
			f[j]/=total_weight;	
		
		for(k=0;k<20;k++)
		{
			g[k]=0;
			for(j=0;j<20;j++)
			{
				score=blosum62[aarank2psi[k]][aarank2psi[j]];
				g[k]+=f[j]*P[k]*exp(lamba*score);
			}
		}
		for(j=0;j<20;j++)
		{
			alpha=nc[i];
			//alpha=len_colum;
			beta=10;
			Q[j]=(alpha*f[j]+beta*g[j])/(alpha+beta);			
		}
		freq[i]=Q;
	}
	

	sequ=all_seq[0].seq;
	
	one_profile.resize(20);
	string tempstr;
	for(i=0;i<(int)miss.size();i++)
	{
		po=miss[i]-1;
		if((po>=0)&&(po<(int)standseq.length()))
		{
			aa=standseq[po];
			tempstr=aa;
			sequ.insert(po,tempstr);
			k=Rname2ID20(aa);
			for(j=0;j<20;j++)
				one_profile[j]=0;
			if(k!=-1)
				one_profile[k]=1.0;
			freq.insert(freq.begin()+po,one_profile);
		}
	}
	return true;
}

bool psi_log(string filename,vector<vector<double> >& logprofile,string& sequence,string standseq)
{
	vector<double> one_prof;
	vector<int> miss;
	
	string line;
	int i,j,k,id,preid,len,po;
	double td;
	char c;
	if(filename.empty())
		return false;
	sequence.clear();
	logprofile.clear();
	one_prof.resize(20);
	ifstream filein(filename.c_str());
	if(!filein.is_open())
		return false;
	getline(filein,line);
	getline(filein,line);
	getline(filein,line);

	getline(filein,line);
	preid=0;
	while(!line.empty())
	{	
		stringstream ss(line);
		ss>>id>>c;
		if(id!=preid+1)
		{
			for(i=preid+1;i<id;i++)
				miss.push_back(i);
		}
		preid=id;
		if(c=='X')
			c='U';
		sequence.push_back(c);
		for(i=0;i<20;i++)
		{
			ss>>td;
			one_prof[aapsi2rank[i]]=td;
		}
		logprofile.push_back(one_prof);
		
		getline(filein,line);
	}
	len=(int)standseq.length();
	for(i=preid+1;i<=len;i++)
		miss.push_back(i);

	
	one_prof.resize(20);
	char aa;
	string tempstr;
	for(i=0;i<(int)miss.size();i++)
	{
		po=miss[i]-1;
		if((po>=0)&&(po<(int)standseq.length()))
		{
			aa=standseq[po];
			tempstr=aa;
			sequence.insert(po,tempstr);
			k=Rname2ID20(aa);
			if(k==-1)
			{
				for(j=0;j<20;j++)
					one_prof[j]=-4;
			}
			else
			{
				for(j=0;j<20;j++)
					one_prof[j]=blosum62[aarank2psi[k]][aarank2psi[j]];
			}
			logprofile.insert(logprofile.begin()+po,one_prof);
		}
	}

	if(filein.eof())
		return false;
	else
		return true;
}

bool read_multiali_psi(string filename,vector<sequence>& all_seq,vector<int>& miss)
{
	sequence tempseq;
	hash_map<string,int> hm;
	hash_map<string,int>::iterator hmi;
	string line,subline,subname,seq;
	vector<int> flag;
	int i,j,len,po,p1,p2,sublen,count,start_po;
	int block=0;
	int total_len=0;
	int block_end;
	
	miss.clear();
	if(filename.empty())
		return false;
	all_seq.clear();
	ifstream filein(filename.c_str());
	if(!filein.is_open())
		return false;
	while(!filein.eof())
	{
		getline(filein,line);
		if(line=="Results from round 10"||line=="CONVERGED!")
				break;
	}
	if(filein.eof())
		return false;	
	if(filein.eof())
		return false;
	tempseq.name="QUERY";
	all_seq.push_back(tempseq);
	hm.insert(make_pair<string,int>(tempseq.name ,(int)all_seq.size()-1));
	flag.push_back(1);
	block_end=0;
	bool find=false;
	while((!find)&&(!filein.eof()))
	{
		getline(filein,line);
		if(line.empty())
			continue;
		if(line.substr(0,5)=="QUERY")
		{
			find=true;
			stringstream ss(line);
			ss>>subname>>p1>>seq>>p2;
			all_seq[0].seq+=seq;
			sublen=p2-p1+1;
			all_seq[0].start=p1;
			all_seq[0].end=p2;
			for(i=5;i<(int)line.length();i++)
			{
				if(isalpha(line[i]))
					break;
			}
			if(i<(int)line.length())
				start_po=i;
			else
			{
				cout<<"error"<<endl;
				return false;
			}
			if(p1-block_end>1)
			{
				for(i=block_end+1;i<p1;i++)
					miss.push_back(i);
			}
			block_end=p2;
		}		
	}	
	if(filein.eof())
		return false;
	block=1;
	total_len=sublen;
	while(!filein.eof())
	{
		getline(filein,line);
		if(line.empty())
			continue;				
		stringstream ss(line);
		ss>>subline;
		if(subline=="Database:"||subline=="Results")
			break;
		if((int)line.length()<10)
			continue;
		if(line.substr(0,5)=="     ")
			continue;
		ss>>p1>>seq>>p2;
		hmi=hm.find(subline);
		if(hmi==hm.end())
		{
			seq.clear();
			if(total_len-sublen>0)
			{				
				for(i=0;i<total_len-sublen;i++)
					seq.push_back(' ');
			}
			seq+=line.substr(start_po,sublen);
			tempseq.Clear();
			tempseq.name=subline;
			tempseq.seq=seq;
			tempseq.start=p1;
			tempseq.end=p2;
			all_seq.push_back(tempseq);
			hm.insert(make_pair<string,int>(subline,(int)all_seq.size()-1));
			flag.push_back(1);
		}
		else
		{	
			po=hmi->second;
			if(po==0)
			{
				block++;
				sublen=p2-p1+1;
				total_len+=sublen;				
				all_seq[0].seq+=seq;
				if(all_seq[0].start>p1)
					all_seq[0].start=p1;
				if(all_seq[0].end<p2)
					all_seq[0].end=p2;
				for(i=0;i<(int)flag.size();i++)
					flag[i]=0;
				flag[0]=1;
				for(i=5;i<(int)line.length();i++)
				{
					if(isalpha(line[i]))
						break;
				}
				if(i<(int)line.length())
					start_po=i;
				else
				{
					cout<<"error"<<endl;
					return false;
				}
				if(p1-block_end>1)
				{
					for(i=block_end+1;i<p1;i++)
						miss.push_back(i);
				}
				block_end=p2;
			}	
			else
			{
				if(flag[po])
				{
					subline+="_1";
					hmi=hm.find(subline);
					if(hmi==hm.end())
					{
						seq.clear();
						if(total_len-sublen>0)
						{				
							for(i=0;i<total_len-sublen;i++)
								seq.push_back(' ');
						}
						seq+=line.substr(start_po,sublen);
						tempseq.Clear();
						tempseq.name=subline;
						tempseq.seq=seq;
						tempseq.start=p1;
						tempseq.end=p2;
						all_seq.push_back(tempseq);
						hm.insert(make_pair<string,int>(subline,(int)all_seq.size()-1));
						flag.push_back(1);
					}
					else
					{
						po=hmi->second;
						if(flag[po])
						{
							subline+="_1";
							hmi=hm.find(subline);
							if(hmi==hm.end())
							{
								seq.clear();
								if(total_len-sublen>0)
								{				
									for(i=0;i<total_len-sublen;i++)
										seq.push_back(' ');
								}
								seq+=line.substr(start_po,sublen);
								tempseq.Clear();
								tempseq.name=subline;
								tempseq.seq=seq;
								tempseq.start=p1;
								tempseq.end=p2;
								all_seq.push_back(tempseq);
								hm.insert(make_pair<string,int>(subline,(int)all_seq.size()-1));
								flag.push_back(1);
							}
							else
							{
								po=hmi->second;
								if(flag[po])
								{
									
									continue;
								}
								else
								{
									seq.clear();
									for(i=0;i<total_len-sublen-(int)all_seq[po].seq.length();i++)
										seq.push_back(' ');
									seq+=line.substr(start_po,sublen);
									all_seq[po].seq+=seq;
									if(all_seq[po].start>p1)
										all_seq[po].start=p1;
									if(all_seq[po].end<p2)
										all_seq[po].end=p2;
									flag[po]=1;
								}
							}
						}
						else
						{
							seq.clear();
							for(i=0;i<total_len-sublen-(int)all_seq[po].seq.length();i++)
								seq.push_back(' ');
							seq+=line.substr(start_po,sublen);
							all_seq[po].seq+=seq;
							if(all_seq[po].start>p1)
								all_seq[po].start=p1;
							if(all_seq[po].end<p2)
								all_seq[po].end=p2;
							flag[po]=1;
						}
					}
				}
				else
				{
					seq.clear();
					for(i=0;i<total_len-sublen-(int)all_seq[po].seq.length();i++)
						seq.push_back(' ');
					seq+=line.substr(start_po,sublen);
					all_seq[po].seq+=seq;
					if(all_seq[po].start>p1)
						all_seq[po].start=p1;
					if(all_seq[po].end<p2)
						all_seq[po].end=p2;
					flag[po]=1;
				}
			}
		}
	}
	
	len=(int)all_seq[0].seq.length();
	for(i=1;i<(int)all_seq.size();i++)
	{
		sublen=(int)all_seq[i].seq.length();
		if(sublen!=len)
		{
			if(sublen<len)
			{
				for(j=0;j<(len-sublen);j++)
					all_seq[i].seq.push_back(' ');
			}
			else
			{
				cout<<"error"<<endl;
                return false;
			}
		}
		count=0;
		for(j=0;j<len;j++)
		{
			if(all_seq[i].seq[j]=='.')
				count++;
		}
		all_seq[i].seq_identity=count/(double)len;
	}
	return true;
}

bool write_multiali(string filename,vector<sequence>& all_seq)	
{
	int i;
	if(filename.empty())
		return false;
	ofstream fileout(filename.c_str());
	if(!fileout.is_open())
		return false;
	fileout<<(int)all_seq.size()<<endl;
	for(i=0;i<(int)all_seq.size();i++)
	{
		fileout<<all_seq[i].name<<"\t"<<all_seq[i].seq<<endl;
	}
	return true;
}

bool write_multiali_clustalw(string filename,vector<sequence>& all_seq,string standseq)	
{
	int i;
	string seq;
	if(filename.empty())
		return false;
	ofstream fileout(filename.c_str());
	if(!fileout.is_open())
		return false;
	for(i=0;i<(int)all_seq.size();i++)
	{
		if(i==0)
		{
			if(!ConvertSeq_Query(all_seq[i].seq,standseq,seq))
				return false;
		}
		else
		{
            if(!ConvertSeq(all_seq[i].seq,standseq,seq))
				return false;
		}
		fileout<<all_seq[i].name<<"\t"<<seq<<endl;
	}
	return true;
}
	
bool write_profile(string id,const vector<vector<double> >& profile,const string seq,int type,string dir)
{
	string filename;
	int i,j,len;
	filename=dir+"\\"+id;
	if(type==1)
		filename+=".frp";
	else if(type==2)
		filename+=".lop";
	else
		return false;
	len=(int)profile.size();
	if(len!=(int)seq.length())
		return false;
	ofstream fileout(filename.c_str());
	if(!fileout.is_open())
		return false;
	
	fileout<<'\t'<<'\t';
	for(i=0;i<20;i++)
		fileout<<rname_one_rank20[i]<<'\t';
	fileout<<endl;
	
	for(i=0;i<len;i++)
	{
		fileout<<i+1<<'\t';
		fileout<<seq[i]<<'\t';
		if((int)profile[i].size()<20)
			return false;
		for(j=0;j<20;j++)
			fileout<<profile[i][j]<<'\t';
		fileout<<endl;
	}
	return true;
}

bool read_profile(string id,vector<vector<double> >& profile,string& seq,int type,string dir)
{
	string filename,line;
	ifstream filein;
	int j,ni;
	char c;
	double tempd;
	vector<double> one_profile;
	one_profile.resize(20);

	filename=dir+"\\"+id;
	filein.open(filename.c_str());
	if(!filein.is_open())
	{
		filein.close();
		filein.clear();		
		if(type==1)
			filename+=".frp";
		else if(type==2)
			filename+=".lop";
		else 
			return false;		
		filein.open(filename.c_str());
		if(!filein.is_open())
			return false;
	}	
	profile.clear();
	seq.clear();
	getline(filein,line);
	while(!filein.eof())
	{
		getline(filein,line);
		if(line.empty())
			break;
		stringstream ss(line);
		ss>>ni>>c;
		seq.push_back(c);
		for(j=0;j<20;j++)
		{
			if(ss.eof())
				return false;
			ss>>tempd;
			one_profile[j]=tempd;
		}
		profile.push_back(one_profile);
	}
	return true;
}

bool read_multiali_psi_multimap(string filename,vector<sequence>& all_seq,vector<int>& miss)
{
	sequence tempseq;
	hash_multimap<string,int> hm;
	hash_multimap<string,int>::iterator hmi,hhmi;
	string line,subline,subname,seq;	
	int i,j,len,po,p1,p2,sublen,count,start_po;
	vector<int> usage;
	int block=0;
	int total_len=0;
	int block_end;
	
	miss.clear();
	if(filename.empty())
		return false;
	all_seq.clear();
	ifstream filein(filename.c_str());
	if(!filein.is_open())
		return false;
	while(!filein.eof())
	{
		getline(filein,line);
		if(line=="Results from round 10"||line=="CONVERGED!")
				break;
	}
	if(filein.eof())
		return false;	
	if(filein.eof())
		return false;
	tempseq.name="QUERY";
	all_seq.push_back(tempseq);
	usage.push_back(1);
	hm.insert(make_pair<string,int>(tempseq.name ,(int)all_seq.size()-1));	
	block_end=0;
	bool find=false;
	while((!find)&&(!filein.eof()))
	{
		getline(filein,line);
		if(line.empty())
			continue;
		if(line.substr(0,5)=="QUERY")
		{
			find=true;
			stringstream ss(line);
			ss>>subname>>p1>>seq>>p2;
			all_seq[0].seq+=seq;
			sublen=p2-p1+1;
			all_seq[0].start=p1;
			all_seq[0].end=p2;
			for(i=5;i<(int)line.length();i++)
			{
				if(isalpha(line[i]))
					break;
			}
			if(i<(int)line.length())
				start_po=i;
			else
			{
				cout<<"error"<<endl;
				return false;
			}
			if(p1-block_end>1)
			{
				for(i=block_end+1;i<p1;i++)
					miss.push_back(i);
			}
			block_end=p2;
		}		
	}	
	if(filein.eof())
		return false;
	block=1;
	total_len=sublen;
	while(!filein.eof())
	{
		getline(filein,line);
		if(line.empty())
			continue;				
		stringstream ss(line);
		ss>>subline;
		if(subline=="Database:"||subline=="Results")
			break;
		if((int)line.length()<10)
			continue;
		if(line.substr(0,5)=="     ")
			continue;
		ss>>p1>>seq>>p2;
		hmi=hm.find(subline);
		if(hmi==hm.end())
		{
			seq.clear();
			if(total_len-sublen>0)
			{				
				for(i=0;i<total_len-sublen;i++)
					seq.push_back(' ');
			}
			seq+=line.substr(start_po,sublen);
			tempseq.Clear();
			tempseq.name=subline;
			tempseq.seq=seq;
			tempseq.start=p1;
			tempseq.end=p2;
			all_seq.push_back(tempseq);
			usage.push_back(1);
			hm.insert(make_pair<string,int>(subline,(int)all_seq.size()-1));			
		}
		else
		{	
			po=hmi->second;
			if(po==0)
			{
				block++;
				sublen=p2-p1+1;
				total_len+=sublen;				
				all_seq[0].seq+=seq;
				if(all_seq[0].start>p1)
					all_seq[0].start=p1;
				if(all_seq[0].end<p2)
					all_seq[0].end=p2;				
				for(i=5;i<(int)line.length();i++)
				{
					if(isalpha(line[i]))
						break;
				}
				if(i<(int)line.length())
					start_po=i;
				else
				{
					cout<<"error"<<endl;
					return false;
				}
				if(p1-block_end>1)
				{
					for(i=block_end+1;i<p1;i++)
						miss.push_back(i);
				}
				block_end=p2;
				for(i=0;i<(int)usage.size();i++)
					usage[i]=0;
			}	
			else
			{
				find=false;
				for(hhmi=hmi;hhmi!=hm.end()&&(hhmi->first==hmi->first);hhmi++)
				{
					if((p1==all_seq[hhmi->second].end+1)&&(usage[hhmi->second]==0))
					{
						po=hhmi->second;
						find=true;
						seq.clear();
						for(i=0;i<total_len-sublen-(int)all_seq[po].seq.length();i++)
							seq.push_back(' ');
						seq+=line.substr(start_po,sublen);
						all_seq[po].seq+=seq;
						if(all_seq[po].start>p1)
							all_seq[po].start=p1;
						if(all_seq[po].end<p2)
							all_seq[po].end=p2;	
						usage[po]=1;
						break;
					}
				}
				if(!find)
				{
					seq.clear();
					if(total_len-sublen>0)
					{				
						for(i=0;i<total_len-sublen;i++)
							seq.push_back(' ');
					}
					seq+=line.substr(start_po,sublen);
					tempseq.Clear();
					tempseq.name=subline;
					tempseq.seq=seq;
					tempseq.start=p1;
					tempseq.end=p2;
					all_seq.push_back(tempseq);
					usage.push_back(1);
					hm.insert(make_pair<string,int>(subline,(int)all_seq.size()-1));
				}
			}
		}
	}
				
	
	len=(int)all_seq[0].seq.length();
	for(i=1;i<(int)all_seq.size();i++)
	{
		sublen=(int)all_seq[i].seq.length();
		if(sublen!=len)
		{
			if(sublen<len)
			{
				for(j=0;j<(len-sublen);j++)
					all_seq[i].seq.push_back(' ');
			}
			else
			{
				
				cout<<all_seq[i].seq.c_str()<<endl;
                return false;
			}
		}
		count=0;
		for(j=0;j<len;j++)
		{
			if(all_seq[i].seq[j]=='.')
				count++;
		}
		all_seq[i].seq_identity=count/(double)len;
	}
	return true;
}

double Simi_AliSeq_query(string seq1,string seq2)
{
	int i,len,len1,len2,count;
	
	len1=(int)seq1.length();
	len2=(int)seq2.length();
	if(len1!=len2)
	{
		cout<<"warning: the different length"<<endl;
	}
	len=len1<len2?len1:len2;
	count=0;
	for(i=0;i<len;i++)
	{
		if((seq1[i]==' ')||(seq2[i]==' '))
			continue;
		if((seq1[i]=='.')||(seq2[i]=='.')||(seq1[i]==seq2[i]))
			count++;
	}
	return count/(double)len;
}

double Simi_AliSeq_seq(string seq1,string seq2)
{
	int i,len,len1,len2,count;
	
	len1=(int)seq1.length();
	len2=(int)seq2.length();
	if(len1!=len2)
	{
		
	}
	len=len1<len2?len1:len2;
	count=0;
	for(i=0;i<len;i++)
	{
		if((seq1[i]==' ')||(seq2[i]==' '))
			continue;
		if(seq1[i]==seq2[i])
			count++;
	}
	return count/(double)len;
}
//
bool ConvertSeq(string sseq,string standseq,string& seq)
{
	int i,len;
	len=(int)sseq.size();
	if(len>(int)standseq.size())
		return false;
	seq.resize(standseq.size());
	for(i=0;i<len;i++)
	{
		if(sseq[i]==' ')
			seq[i]='-';
		else if(sseq[i]=='.')
			seq[i]=standseq[i];
		else
			seq[i]=sseq[i];
	}
	for(i=len;i<(int)standseq.size();i++)
		seq[i]='-';
	return true;
}

bool ConvertSeq_Query(string sseq,string standseq,string& seq)
{
	int i,len;
	len=(int)sseq.size();
	if(len>(int)standseq.size())
		return false;
	seq.resize(standseq.size());
	for(i=0;i<len;i++)
	{
		if(sseq[i]==' ')
			seq[i]='-';
		else if(sseq[i]=='.')
			seq[i]=standseq[i];
		else
			seq[i]=sseq[i];
	}
	for(i=len;i<(int)standseq.size();i++)
		seq[i]=standseq[i];
	return true;
}
