
#ifndef _VECTOR_H
#define _VECTOR_H
#include "rd_pdb.h"
#define EPS 1e-5
#define PIHALF          1.570796
#define PI              3.141593
#define TWOPI           6.283185
#define RADIAN          57.29578

double Distance(const Point p1,const Point p2);
Point Diff(const Point p1, const Point p2);
Point Add(const Point p1,const Point p2);
double Dot(const Point p1, const Point p2);
double Vector_Len(const Point p);			
Point Vector_Stre(const Point p,double lam);
Point Cross(const Point p1, const Point p2);
double Dihedralangle(const Point p1, const Point p2, const Point p3, const Point p4);
double Atan2(double y, double x);
double Bond_Angle(const Point p1,const Point p2,const Point p3);
Point Vector_Rotate(const Point a,const Point z,const double theta);
Point LastXYZ(const Point p1,const Point p2,const Point p3,const double theta,const double tao,const double bond_len);
Point PointInLine(const Point p3,const Point z,const double bond_len);
#endif